--[[

for index, force in pairs(game.forces) do
	force.recipes["fill-crude-oil-barrel"].enabled = false
	force.recipes["empty-crude-oil-barrel"].enabled = false
	force.recipes["solder-alloy"].enabled = false
	force.reset_recipes()
	force.reset_technologies()
end


]]--

--[[ Assembly ]] --

table.insert(data.raw.technology["automation-4"].prerequisites, "research")


--[[ Electronics ]] --

data.raw.item["copper-cable"].subgroup = "bob-electronic-components"
data.raw.item["copper-cable"].order = "0-a0[copper-cable]"

table.insert(data.raw.technology["advanced-electronics"].prerequisites, "plastics")
table.insert(data.raw.technology["advanced-electronics"].prerequisites, "silicon-processing")

table.insert(data.raw.technology["circuit-network"].prerequisites, "steel-processing")
table.insert(data.raw.technology["circuit-network"].prerequisites, "basic-research")

table.insert(data.raw.technology["alloy-processing-2"].effects, { type = "unlock-recipe", recipe = "solder-alloy" })
table.insert(data.raw.technology["alloy-processing-2"].prerequisites, "research")

table.insert(data.raw.technology["advanced-electronics-2"].prerequisites, "research")
table.insert(data.raw.technology["advanced-electronics-2"].prerequisites, "sulfur-processing")
table.insert(data.raw.technology["advanced-electronics-2"].prerequisites, "gold-processing")

table.insert(data.raw.technology["advanced-electronics-3"].prerequisites, "advanced-research")

data.raw.technology["laser"].prerequisites = { "electronics", "optics", "basic-research" }
data.raw.technology["robotics"].prerequisites = { "electronics", "electric-engine", "battery", "circuit-network" }

--[[ Enemies ]]--

data:extend(
{
	{
		type = "item-subgroup",
		name = "small-alien-artifacts",
		group = "intermediate-products",
		order = "f",
	},
	{
		type = "item-subgroup",
		name = "alien-artifacts",
		group = "intermediate-products",
		order = "g",
	}
}
)
data.raw["item-subgroup"]["science-pack"].order = "h"

data.raw.item["alien-artifact"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact"].order = "a"
data.raw.item["alien-artifact-red"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-red"].order = "b"
data.raw.item["alien-artifact-orange"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-orange"].order = "c"
data.raw.item["alien-artifact-yellow"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-yellow"].order = "d"
data.raw.item["alien-artifact-green"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-green"].order = "e"
data.raw.item["alien-artifact-blue"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-blue"].order = "f"
data.raw.item["alien-artifact-purple"].subgroup = "alien-artifacts"
data.raw.item["alien-artifact-purple"].order = "g"

data.raw.item["small-alien-artifact"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact"].order = "a"
data.raw.item["small-alien-artifact-red"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-red"].order = "b"
data.raw.item["small-alien-artifact-orange"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-orange"].order = "c"
data.raw.item["small-alien-artifact-yellow"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-yellow"].order = "d"
data.raw.item["small-alien-artifact-green"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-green"].order = "e"
data.raw.item["small-alien-artifact-blue"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-blue"].order = "f"
data.raw.item["small-alien-artifact-purple"].subgroup = "small-alien-artifacts"
data.raw.item["small-alien-artifact-purple"].order = "g"


--[[ Logistics ]]--

data.raw.item["logistic-chest-active-provider"].subgroup = "storage"
data.raw.item["logistic-chest-passive-provider"].subgroup = "storage"
data.raw.item["logistic-chest-requester"].subgroup = "storage"
data.raw.item["logistic-chest-storage"].subgroup = "storage"

data.raw.item["logistic-chest-active-provider"].order = "a[items]-e[active-provider]"
data.raw.item["logistic-chest-passive-provider"].order = "a[items]-f[passive-provider]"
data.raw.item["logistic-chest-requester"].order = "a[items]-g[requester]"
data.raw.item["logistic-chest-storage"].order = "a[items]-h[storage]"

data.raw.item["storage-tank"].subgroup = "bob-storage"

data:extend(
{
	{
		type = "item-subgroup",
		name = "belt",
		group = "logistics",
		order = "b",
	},
	{
		type = "item-subgroup",
		name = "belt-to-ground",
		group = "logistics",
		order = "c",
	},
	{
		type = "item-subgroup",
		name = "belt-splitter",
		group = "logistics",
		order = "d",
	},
	{
		type = "item-subgroup",
		name = "train-system",
		group = "logistics",
		order = "g",
	},
	{
		type = "item-subgroup",
		name = "rail-stock",
		group = "logistics",
		order = "h",
	},
	{
		type = "item-subgroup",
		name = "fast-inserter",
		group = "bob-logistics",
		order = "h",
	},
}
)

data.raw.item["green-transport-belt"].subgroup = "belt"
data.raw.item["purple-transport-belt"].subgroup = "belt"

data.raw.item["basic-transport-belt-to-ground"].subgroup = "belt-to-ground"
data.raw.item["fast-transport-belt-to-ground"].subgroup = "belt-to-ground"
data.raw.item["express-transport-belt-to-ground"].subgroup = "belt-to-ground"
data.raw.item["green-transport-belt-to-ground"].subgroup = "belt-to-ground"
data.raw.item["purple-transport-belt-to-ground"].subgroup = "belt-to-ground"

data.raw.item["basic-splitter"].subgroup = "belt-splitter"
data.raw.item["fast-splitter"].subgroup = "belt-splitter"
data.raw.item["express-splitter"].subgroup = "belt-splitter"
data.raw.item["green-splitter"].subgroup = "belt-splitter"
data.raw.item["purple-splitter"].subgroup = "belt-splitter"

data.raw.recipe["green-transport-belt"].category = "crafting-with-fluid"
data.raw.recipe["purple-transport-belt"].category = "crafting-with-fluid"
data.raw.recipe["green-transport-belt-to-ground"].category = "crafting-with-fluid"
data.raw.recipe["purple-transport-belt-to-ground"].category = "crafting-with-fluid"
data.raw.recipe["green-splitter"].category = "crafting-with-fluid"
data.raw.recipe["purple-splitter"].category = "crafting-with-fluid"

bobmods.lib.replace_recipe_item("express-transport-belt", "iron-gear-wheel", "steel-gear-wheel")
bobmods.lib.replace_recipe_item("express-transport-belt-to-ground", "iron-gear-wheel", "steel-gear-wheel")
bobmods.lib.replace_recipe_item("express-splitter", "iron-gear-wheel", "steel-gear-wheel")

bobmods.lib.add_new_recipe_item("green-transport-belt", { type = "fluid", name = "lubricant", amount = 3 })
bobmods.lib.add_new_recipe_item("green-transport-belt-to-ground", { type = "fluid", name = "lubricant", amount = 15 })
bobmods.lib.add_new_recipe_item("green-splitter", { type = "fluid", name = "lubricant", amount = 10 })

table.insert(data.raw.recipe["purple-transport-belt"].ingredients, { type = "fluid", name = "lubricant", amount = 4 })
table.insert(data.raw.recipe["purple-transport-belt-to-ground"].ingredients, { type = "fluid", name = "lubricant", amount = 20 })
table.insert(data.raw.recipe["purple-splitter"].ingredients, { type = "fluid", name = "lubricant", amount = 15 })

data.raw["item-subgroup"]["inserter"].group = "bob-logistics"
data.raw["item-subgroup"]["inserter"].order = "b"
data.raw["item-subgroup"]["fast-inserter"].order = "c"
data.raw["item-subgroup"]["bob-smart-inserter"].group = "bob-logistics"
data.raw["item-subgroup"]["bob-smart-inserter"].order = "d"

data.raw.item["fast-near-inserter"].subgroup = "fast-inserter"
data.raw.item["fast-inserter"].subgroup = "fast-inserter"
data.raw.item["fast-far-inserter"].subgroup = "fast-inserter"
data.raw.item["fast-long-inserter"].subgroup = "fast-inserter"

data.raw["item-subgroup"]["energy-pipe-distribution"].order = "e"

data.raw.item["straight-rail"].subgroup = "train-system"
data.raw.item["curved-rail"].subgroup = "train-system"
data.raw.item["train-stop"].subgroup = "train-system"
data.raw.item["rail-signal"].subgroup = "train-system"
data.raw.item["rail-chain-signal"].subgroup = "train-system"
data.raw.item["diesel-locomotive"].subgroup = "rail-stock"
data.raw.item["diesel-locomotive"].order = "a[rail-stock]-a[diesel-locomotive]"
data.raw.item["diesel-locomotive-2"].subgroup = "rail-stock"
data.raw.item["diesel-locomotive-2"].order = "a[rail-stock]-b[diesel-locomotive-2]"
data.raw.item["diesel-locomotive-3"].subgroup = "rail-stock"
data.raw.item["diesel-locomotive-3"].order = "a[rail-stock]-c[diesel-locomotive-3]"
data.raw.item["armoured-diesel-locomotive"].subgroup = "rail-stock"
data.raw.item["armoured-diesel-locomotive"].order = "a[rail-stock]-d[armoured-diesel-locomotive]"

data.raw.item["cargo-wagon"].subgroup = "rail-stock"
data.raw.item["cargo-wagon"].order = "a[rail-stock]-e[cargo-wagon]"
data.raw.item["cargo-wagon-2"].subgroup = "rail-stock"
data.raw.item["cargo-wagon-2"].order = "a[rail-stock]-f[cargo-wagon-2]"
data.raw.item["cargo-wagon-3"].subgroup = "rail-stock"
data.raw.item["cargo-wagon-3"].order = "a[rail-stock]-g[cargo-wagon-3]"
data.raw.item["armoured-cargo-wagon"].subgroup = "rail-stock"
data.raw.item["armoured-cargo-wagon"].order = "a[rail-stock]-h[armoured-cargo-wagon]"

data.raw["item-subgroup"]["transport"].order = "i"
data.raw["item-subgroup"]["logistic-network"].order = "j"
data.raw["item-subgroup"]["circuit-network"].order = "k"
data.raw["item-subgroup"]["terrain"].order = "l"


data.raw.item["logistic-robot"].subgroup = "bob-logistic-robots"
data.raw.item["construction-robot"].subgroup = "bob-logistic-robots"
data.raw.item["bob-roboport-2"].subgroup = "logistic-network"
data.raw.item["bob-roboport-3"].subgroup = "logistic-network"
data.raw.item["bob-roboport-4"].subgroup = "logistic-network"

data.raw.item["flying-robot-frame"].subgroup = "bob-intermediates"

data.raw["roboport"]["roboport"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
data.raw["roboport"]["bob-roboport-2"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
data.raw["roboport"]["bob-roboport-3"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }
data.raw["roboport"]["bob-roboport-4"].radius_visualisation_picture = { filename = "__bobtweaks__/graphics/roboport-radius-visualization.png", width = 12, height = 12 }

data.raw["repair-tool"]["repair-pack"].subgroup = "energy"
data.raw["blueprint"]["blueprint"].subgroup = "energy"
data.raw["deconstruction-item"]["deconstruction-planner"].subgroup = "energy"

table.insert(data.raw.technology["inserter-stack-size-bonus-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["inserter-stack-size-bonus-3"].prerequisites, "research")
table.insert(data.raw.technology["inserter-stack-size-bonus-4"].prerequisites, "alien-technology")
table.insert(data.raw.technology["long-inserters-2"].prerequisites, "basic-research")
table.insert(data.raw.technology["near-inserters-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["logistics-2"].prerequisites, "basic-research")
table.insert(data.raw.technology["engine"].prerequisites, "basic-research")
table.insert(data.raw.technology["bob-logistics-5"].prerequisites, "alien-technology")


data.raw.technology["electric-engine"].prerequisites = { "engine", "electronics", "oil-processing" }

table.insert(data.raw.technology["logistics-3"].prerequisites, "research")
table.insert(data.raw.technology["logistic-system"].prerequisites, "research")
table.insert(data.raw.technology["logistic-robot-speed-1"].prerequisites, "research")
table.insert(data.raw.technology["logistic-robot-storage-1"].prerequisites, "research")
table.insert(data.raw.technology["character-logistic-slots-3"].prerequisites, "research")
table.insert(data.raw.technology["character-logistic-slots-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["character-logistic-slots-7"].prerequisites, "alien-technology")
table.insert(data.raw.technology["character-logistic-slots-8"].prerequisites, "alien-research")
table.insert(data.raw.technology["character-logistic-trash-slots-2"].prerequisites, "research")
table.insert(data.raw.technology["logistic-robot-speed-3"].prerequisites, "alien-technology")
table.insert(data.raw.technology["logistic-robot-storage-2"].prerequisites, "alien-technology")

--[[ Mining ]]--


--[[ Modules ]]--

table.insert(data.raw.technology["modules"].prerequisites, "aluminium-processing")
table.insert(data.raw.technology["modules"].prerequisites, "gold-processing")

table.insert(data.raw["recipe"]["speed-module-3"].ingredients, { "module-contact", 5 })
table.insert(data.raw["recipe"]["effectivity-module-3"].ingredients, { "module-contact", 5 })
table.insert(data.raw["recipe"]["productivity-module-3"].ingredients, { "module-contact", 5 })
table.insert(data.raw["recipe"]["pollution-clean-module-3"].ingredients, { "module-contact", 5 })
table.insert(data.raw["recipe"]["pollution-create-module-3"].ingredients, { "module-contact", 5 })

table.insert(data.raw.technology["speed-module-5"].prerequisites, "gem-processing-2")
table.insert(data.raw.technology["effectivity-module-5"].prerequisites, "gem-processing-2")
table.insert(data.raw.technology["productivity-module-5"].prerequisites, "gem-processing-2")
table.insert(data.raw.technology["pollution-clean-module-5"].prerequisites, "gem-processing-2")
table.insert(data.raw.technology["pollution-create-module-5"].prerequisites, "gem-processing-2")

table.insert(data.raw.technology["effect-transmission-2"].prerequisites, "aluminium-processing")
table.insert(data.raw.technology["effect-transmission-3"].prerequisites, "alien-technology")
table.insert(data.raw.technology["effect-transmission-3"].prerequisites, "titanium-processing")


--[[ Ores ]]--

data.raw.item["stone"].subgroup = "bob-ores"
data.raw.item["iron-ore"].subgroup = "bob-ores"
data.raw.item["copper-ore"].subgroup = "bob-ores"
data.raw.item["coal"].subgroup = "bob-ores"
data.raw.item["raw-wood"].subgroup = "bob-ores"

data.raw.item["stone"].order = "f-a[stone]"
data.raw.item["iron-ore"].order = "f-a[iron-ore]"
data.raw.item["copper-ore"].order = "f-a[copper-ore]"
data.raw.item["coal"].order = "f-a[coal]"
data.raw.item["raw-wood"].order = "f-z[coal]"


--[[ Plates ]]--

data.raw.item["small-pump"].subgroup = "bob-pump"
data.raw.item["small-pump"].order = "e[air-pump-0]"

for i, effect in pairs(data.raw.technology["fluid-handling"].effects) do
	if effect.recipe == "empty-crude-oil-barrel" then table.remove(data.raw.technology["fluid-handling"].effects, i) end
end

for i, effect in pairs(data.raw.technology["fluid-handling"].effects) do
	if effect.recipe == "empty-barrel" then table.remove(data.raw.technology["fluid-handling"].effects, i) end
end

for i, effect in pairs(data.raw.technology["fluid-handling"].effects) do
	if effect.recipe == "fill-crude-oil-barrel" then table.remove(data.raw.technology["fluid-handling"].effects, i) end
end

for i, effect in pairs(data.raw.technology["fluid-handling"].effects) do
	if effect.recipe == "small-pump" then table.remove(data.raw.technology["fluid-handling"].effects, i) end
end

table.insert(data.raw.technology["barrels"].prerequisites, "fluid-handling")

table.insert(data.raw.technology["electric-engine"].effects, { type = "unlock-recipe", recipe = "small-pump" })

data:extend(
{
	{
		type = "item-subgroup",
		name = "bob-gas-unbottle",
		group = "bob-fluid-products",
		order = "a-f",
	},
	{
		type = "item-subgroup",
		name = "bob-unbarrel",
		group = "bob-fluid-products",
		order = "a-h",
	},
	{
		type = "item-subgroup",
		name = "bob-canister",
		group = "bob-fluid-products",
		order = "a-i",
	},
	{
		type = "item-subgroup",
		name = "bob-uncanister",
		group = "bob-fluid-products",
		order = "a-j",
	},
	{
		type = "technology",
		name = "research",
		icon = "__bobtweaks__/graphics/chemistry.png",
		prerequisites =
		{
			"battery",
			"steel-processing",
			"advanced-electronics",
			"basic-research"
		},
		effects =
		{
			{
				type = "unlock-recipe",
				recipe = "science-pack-3"
			}
		},
		unit =
		{
			count = 100,
			ingredients =
			{
				{ "science-pack-1", 1 },
				{ "science-pack-2", 1 },
			},
			time = 30
		},
		order = "c-k-m-1"
	},
	{
		type = "technology",
		name = "basic-research",
		icon = "__bobtweaks__/graphics/basic-research.png",
		prerequisites =
		{
		},
		effects =
		{
			{
				type = "unlock-recipe",
				recipe = "science-pack-2"
			}
		},
		unit =
		{
			count = 50,
			ingredients =
			{
				{ "science-pack-1", 1 }
			},
			time = 15
		},
		order = "c-k-m-0"
	}
}
)

data.raw.recipe["science-pack-2"].enabled = false

data.raw["item-subgroup"]["barrel"].group = "bob-fluid-products"
data.raw["item-subgroup"]["barrel"].order = "a-d"
data.raw["item-subgroup"]["bob-gas-bottle"].order = "a-e"
data.raw["item-subgroup"]["bob-barrel"].order = "a-g"

data.raw.recipe["empty-barrel"].subgroup = "barrel"
data.raw.recipe["gas-canister"].subgroup = "barrel"
data.raw.recipe["empty-canister"].subgroup = "barrel"

data.raw.recipe["empty-chlorine-canister"].subgroup = "bob-gas-unbottle"
data.raw.recipe["empty-hydrogen-canister"].subgroup = "bob-gas-unbottle"
data.raw.recipe["empty-oxygen-canister"].subgroup = "bob-gas-unbottle"
data.raw.recipe["empty-nitrogen-canister"].subgroup = "bob-gas-unbottle"
data.raw.recipe["empty-hydrogen-chloride-canister"].subgroup = "bob-gas-unbottle"
data.raw.recipe["empty-petroleum-gas-canister"].subgroup = "bob-gas-unbottle"

data.raw.recipe["empty-heavy-oil-barrel"].subgroup = "bob-unbarrel"
data.raw.recipe["empty-light-oil-barrel"].subgroup = "bob-unbarrel"
data.raw.recipe["empty-lubricant-barrel"].subgroup = "bob-unbarrel"
data.raw.recipe["empty-sulfuric-acid-barrel"].subgroup = "bob-unbarrel"
data.raw.recipe["bob-empty-crude-oil-barrel"].subgroup = "bob-unbarrel"

data.raw.recipe["liquid-fuel-canister"].subgroup = "bob-canister"
data.raw.recipe["ferric-chloride-canister"].subgroup = "bob-canister"

data.raw.recipe["empty-liquid-fuel-canister"].subgroup = "bob-uncanister"
data.raw.recipe["empty-ferric-chloride-canister"].subgroup = "bob-uncanister"

data.raw.item["gas-canister"].subgroup = "bob-gas-bottle"
data.raw.item["empty-barrel"].subgroup = "bob-barrel"
data.raw.item["crude-oil-barrel"].subgroup = "bob-barrel"
data.raw.item["empty-canister"].subgroup = "bob-canister"
data.raw.item["liquid-fuel-canister"].subgroup = "bob-canister"
data.raw.item["ferric-chloride-canister"].subgroup = "bob-canister"

data.raw.item["lithium-ion-battery"].subgroup = "intermediate-product"
data.raw.item["lithium-ion-battery"].order = "i[lithium-ion-battery]"

data.raw.item["silver-zinc-battery"].subgroup = "intermediate-product"
data.raw.item["silver-zinc-battery"].order = "i[silver-zinc-battery]"

data.raw.item["iron-gear-wheel"].subgroup = "bob-gears"
data.raw.item["iron-gear-wheel"].order = "a[iron-gear-wheel]"

data.raw.item["iron-plate"].subgroup = "bob-material"
data.raw.item["iron-plate"].order = "c-a-0[iron-plate]"
data.raw.item["copper-plate"].subgroup = "bob-material"
data.raw.item["copper-plate"].order = "c-a-0[copper-plate]"
data.raw.item["steel-plate"].subgroup = "bob-alloy"
data.raw.item["steel-plate"].order = "c-b-0[steel-plate]"

data.raw.recipe["iron-plate"].subgroup = "bob-material"
data.raw.recipe["iron-plate"].order = "c-a-0[iron-plate]"
data.raw.recipe["copper-plate"].subgroup = "bob-material"
data.raw.recipe["copper-plate"].order = "c-a-0[copper-plate]"
data.raw.recipe["steel-plate"].subgroup = "bob-alloy"
data.raw.recipe["steel-plate"].order = "c-b-0[steel-plate]"

data.raw.recipe["wood"].subgroup = "bob-resource"
data.raw.recipe["wood"].order = "0[wood]"
data.raw.item["wood"].subgroup = "bob-resource"
data.raw.recipe["plastic-bar"].subgroup = "bob-resource"
data.raw.item["plastic-bar"].subgroup = "bob-resource"
data.raw.recipe["sulfur"].subgroup = "bob-resource-chemical"
data.raw.item["sulfur"].subgroup = "bob-resource-chemical"

if data.raw.technology["optics"].prerequisites == nil then
	data.raw.technology["optics"].prerequisites = { }
end
if data.raw.technology["logistics"].prerequisites == nil then
	data.raw.technology["logistics"].prerequisites = { }
end
if data.raw.technology["toolbelt"].prerequisites == nil then
	data.raw.technology["toolbelt"].prerequisites = { }
end

table.insert(data.raw.technology["invar-processing"].prerequisites, "basic-research")
table.insert(data.raw.technology["oil-processing"].prerequisites, "basic-research")
table.insert(data.raw.technology["advanced-material-processing"].prerequisites, "basic-research")
table.insert(data.raw.technology["cobalt-processing"].prerequisites, "sulfur-processing")
table.insert(data.raw.technology["gas-canisters"].prerequisites, "basic-research")
table.insert(data.raw.technology["lithium-processing"].prerequisites, "basic-research")
table.insert(data.raw.technology["electronics"].prerequisites, "chemical-processing-1")
table.insert(data.raw.technology["electronics"].prerequisites, "alloy-processing-1")
table.insert(data.raw.technology["water-bore-1"].prerequisites, "electronics")
table.insert(data.raw.technology["optics"].prerequisites, "electronics")
table.insert(data.raw.technology["logistics"].prerequisites, "electronics")
table.insert(data.raw.technology["air-compressor-1"].prerequisites, "electronics")
table.insert(data.raw.technology["void-fluid"].prerequisites, "air-compressor-1")
table.insert(data.raw.technology["titanium-processing"].prerequisites, "research")
table.insert(data.raw.technology["tungsten-processing"].prerequisites, "research")
table.insert(data.raw.technology["toolbelt"].prerequisites, "basic-research")
table.insert(data.raw.technology["toolbelt-2"].prerequisites, "research")
table.insert(data.raw.technology["toolbelt-3"].prerequisites, "advanced-research")
table.insert(data.raw.technology["research-effectivity-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["research-effectivity-3"].prerequisites, "research")
table.insert(data.raw.technology["advanced-oil-processing"].prerequisites, "research")
table.insert(data.raw.technology["ceramics"].prerequisites, "research")
table.insert(data.raw.technology["ceramics"].prerequisites, "oil-processing")
table.insert(data.raw.technology["nitroglycerin-processing"].prerequisites, "research")
table.insert(data.raw.technology["nitroglycerin-processing"].prerequisites, "sulfur-processing")
table.insert(data.raw.technology["electrum-processing"].prerequisites, "research")
table.insert(data.raw.technology["nitinol-processing"].prerequisites, "advanced-research")

for i, effect in pairs(data.raw.technology["sulfur-processing"].effects) do
	if effect.recipe == "sulfur-2" then table.remove(data.raw.technology["sulfur-processing"].effects, i) end
end

for i, effect in pairs(data.raw.technology["sulfur-processing"].effects) do
	if effect.recipe == "sulfuric-acid-2" then table.remove(data.raw.technology["sulfur-processing"].effects, i) end
end

table.insert(data.raw.technology["lead-processing"].effects, { type = "unlock-recipe", recipe = "sulfur-2" })
table.insert(data.raw.technology["lead-processing"].effects, { type = "unlock-recipe", recipe = "sulfuric-acid-2" })

data.raw.technology["advanced-electronics-3"].icon = "__base__/graphics/technology/advanced-electronics-2.png",

table.insert(data.raw.technology["gem-processing-2"].prerequisites, "research")

table.insert(data.raw.technology["electrolysis-2"].prerequisites, "basic-research")
table.insert(data.raw.technology["electrolysis-4"].prerequisites, "ceramics")
data.raw.technology["electrolysis-5"].prerequisites = { "electrolysis-4", "tungsten-alloy-processing", "nitinol-processing", "advanced-electronics-3", }

table.insert(data.raw.technology["chemical-processing-2"].prerequisites, "electronics")
table.insert(data.raw.technology["chemical-processing-3"].prerequisites, "research")
table.insert(data.raw.technology["chemical-processing-5"].prerequisites, "tungsten-processing")

table.insert(data.raw.technology["tungsten-alloy-processing"].prerequisites, "advanced-research")

--[[ Power ]]--

data:extend(
{
	{
		type = "item-subgroup",
		name = "energy-substations",
		group = "logistics",
		order = "f",
	},
}
)


data.raw.item["substation"].subgroup = "energy-substations"
data.raw.item["substation-2"].subgroup = "energy-substations"
data.raw.item["substation-3"].subgroup = "energy-substations"
data.raw.item["substation-4"].subgroup = "energy-substations"

data.raw.item["solar-panel-small"].order = "a"
data.raw.item["solar-panel-small-2"].order = "b"
data.raw.item["solar-panel-small-3"].order = "c"
data.raw.item["solar-panel"].order = "d"
data.raw.item["solar-panel-2"].order = "e"
data.raw.item["solar-panel-3"].order = "f"
data.raw.item["solar-panel-large"].order = "g"
data.raw.item["solar-panel-large-2"].order = "h"
data.raw.item["solar-panel-large-3"].order = "i"

data.raw.item["basic-accumulator"].order = "a"
data.raw.item["fast-accumulator"].order = "b"
data.raw.item["fast-accumulator-2"].order = "c"
data.raw.item["fast-accumulator-3"].order = "d"
data.raw.item["large-accumulator"].order = "e"
data.raw.item["large-accumulator-2"].order = "f"
data.raw.item["large-accumulator-3"].order = "g"
data.raw.item["slow-accumulator"].order = "h"
data.raw.item["slow-accumulator-2"].order = "i"
data.raw.item["slow-accumulator-3"].order = "j"

table.insert(data.raw.technology["battery"].prerequisites, "lead-processing")
data.raw.technology["battery"].effects = { { type = "unlock-recipe", recipe = "battery" } }
table.insert(data.raw.technology["battery-2"].prerequisites, "research")
table.insert(data.raw.technology["battery-3"].prerequisites, "advanced-research")

table.insert(data.raw.technology["bob-boiler-2"].prerequisites, "invar-processing")
table.insert(data.raw.technology["bob-boiler-2"].prerequisites, "zinc-processing")
data.raw.technology["bob-boiler-3"].prerequisites = { "bob-boiler-2", "tungsten-processing" }
table.insert(data.raw.technology["electric-pole-2"].prerequisites, "zinc-processing")
table.insert(data.raw.technology["electric-pole-3"].prerequisites, "research")
table.insert(data.raw.technology["electric-pole-3"].prerequisites, "titanium-processing")
table.insert(data.raw.technology["electric-pole-4"].prerequisites, "nitinol-processing")
table.insert(data.raw.technology["electric-pole-4"].prerequisites, "advanced-electronics-3")
table.insert(data.raw.technology["electric-energy-distribution-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["electric-energy-distribution-2"].prerequisites, "advanced-electronics")
table.insert(data.raw.technology["electric-energy-distribution-2"].prerequisites, "research")
table.insert(data.raw.technology["steam-engine-generator-2"].prerequisites, "titanium-processing")

table.insert(data.raw.technology["solar-energy"].prerequisites, "basic-research")
table.insert(data.raw.technology["bob-solar-energy-3"].prerequisites, "research")
data.raw.technology["bob-solar-energy-4"].prerequisites = { "bob-solar-energy-3", "advanced-research", "titanium-processing", "electrum-processing" }

table.insert(data.raw.technology["electric-substation-2"].prerequisites, "aluminium-processing")
table.insert(data.raw.technology["electric-substation-3"].prerequisites, "titanium-processing")
table.insert(data.raw.technology["electric-substation-4"].prerequisites, "advanced-electronics-3")
table.insert(data.raw.technology["electric-substation-4"].prerequisites, "nitinol-processing")


--[[ Tech ]]--

data:extend(
{
	{
		type = "item-subgroup",
		name = "alien-science-pack",
		group = "intermediate-products",
		order = "i",
	}
}
)


data.raw.tool["alien-science-pack"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack"].order = "a"
data.raw.tool["alien-science-pack-red"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-red"].order = "b"
data.raw.tool["alien-science-pack-orange"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-orange"].order = "c"
data.raw.tool["alien-science-pack-yellow"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-yellow"].order = "d"
data.raw.tool["alien-science-pack-green"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-green"].order = "e"
data.raw.tool["alien-science-pack-blue"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-blue"].order = "f"
data.raw.tool["alien-science-pack-purple"].subgroup = "alien-science-pack"
data.raw.tool["alien-science-pack-purple"].order = "g"

data.raw.technology["advanced-research"].prerequisites = { "logistics-3", "advanced-electronics-2", "ceramics", "battery-2" }


data:extend(
{
	{
		type = "technology",
		name = "alien-technology",
		icon = "__base__/graphics/technology/alien-technology.png",
		effects =
		{
			{
				type = "unlock-recipe",
				recipe = "alien-science-pack"
			}
		},
		prerequisites = { "rocketry", "advanced-research" },
		unit =
		{
			count = 300,
			ingredients =
			{
				{ "science-pack-1", 1 },
				{ "science-pack-2", 1 },
				{ "science-pack-3", 1 },
				{ "science-pack-4", 1 },
			},
			time = 30
		},
		order = "e-f"
	},
}
)


--[[ Warfare ]]--

if data.raw.technology["gates"].prerequisites == nil then
	data.raw.technology["gates"].prerequisites = { }
end
table.insert(data.raw.technology["gates"].prerequisites, "basic-research")
table.insert(data.raw.technology["gates"].prerequisites, "electronics")

table.insert(data.raw.technology["combat-robotics"].prerequisites, "electronics")
table.insert(data.raw.technology["combat-robotics-2"].prerequisites, "advanced-electronics")
table.insert(data.raw.technology["combat-robotics-3"].prerequisites, "alien-technology")

table.insert(data.raw.technology["rocketry"].prerequisites, "tungsten-processing")
table.insert(data.raw.technology["tanks"].prerequisites, "advanced-electronics")
table.insert(data.raw.technology["tanks"].prerequisites, "plastics")
table.insert(data.raw.technology["tanks"].prerequisites, "explosives")
table.insert(data.raw.technology["bob-robot-tanks"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-piercing-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-impact-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-explosive-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-acid-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-flame-rocket"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-poison-rocket"].prerequisites, "advanced-electronics-2")

table.insert(data.raw.technology["armor-making-3"].prerequisites, "advanced-electronics-2")
table.insert(data.raw.technology["bob-power-armor-3"].prerequisites, "alien-research")
table.insert(data.raw.technology["bob-turrets-2"].prerequisites, "basic-research")

table.insert(data.raw.technology["bullet-damage-2"].prerequisites, "basic-research")
table.insert(data.raw.technology["bullet-damage-4"].prerequisites, "research")
table.insert(data.raw.technology["bullet-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bullet-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bullet-speed-3"].prerequisites, "basic-research")
table.insert(data.raw.technology["bullet-speed-4"].prerequisites, "research")
table.insert(data.raw.technology["bullet-speed-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bullet-speed-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["shotgun-shell-damage-2"].prerequisites, "basic-research")
table.insert(data.raw.technology["shotgun-shell-damage-4"].prerequisites, "research")
table.insert(data.raw.technology["shotgun-shell-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["shotgun-shell-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["shotgun-shell-speed-3"].prerequisites, "basic-research")
table.insert(data.raw.technology["shotgun-shell-speed-4"].prerequisites, "research")
table.insert(data.raw.technology["shotgun-shell-speed-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["shotgun-shell-speed-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-sniper-turret-damage-4"].prerequisites, "research")
table.insert(data.raw.technology["bob-sniper-turret-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-sniper-turret-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["gun-turret-damage-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["gun-turret-damage-4"].prerequisites, "research")
table.insert(data.raw.technology["gun-turret-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["gun-turret-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["laser-turret-damage-4"].prerequisites, "research")
table.insert(data.raw.technology["laser-turret-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["laser-turret-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["laser-turret-speed-4"].prerequisites, "research")
table.insert(data.raw.technology["laser-turret-speed-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["laser-turret-speed-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["follower-robot-count-3"].prerequisites, "research")
table.insert(data.raw.technology["follower-robot-count-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["combat-robot-damage-3"].prerequisites, "research")
table.insert(data.raw.technology["combat-robot-damage-4"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-sniper-turrets-1"].prerequisites, "basic-research")
table.insert(data.raw.technology["bob-sniper-turrets-2"].prerequisites, "research")
table.insert(data.raw.technology["bob-sniper-turrets-3"].prerequisites, "titanium-processing")
table.insert(data.raw.technology["bob-laser-rifle"].prerequisites, "advanced-electronics")
table.insert(data.raw.technology["bob-laser-rifle-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-laser-rifle-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-laser-rifle-speed-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-laser-rifle-speed-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-tank-cannon-damage-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-tank-cannon-damage-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-tank-cannon-speed-5"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-tank-cannon-speed-6"].prerequisites, "alien-technology")
table.insert(data.raw.technology["bob-laser-rifle-ammo-4"].prerequisites, "advanced-research")
table.insert(data.raw.technology["bob-laser-rifle-ammo-6"].prerequisites, "alien-technology")


table.insert(data.raw.technology["military-2"].prerequisites, "basic-research")
data.raw.technology["military-3"].prerequisites = { "military-2", "aluminium-processing", "laser", "research" }
table.insert(data.raw.technology["military-4"].prerequisites, "alien-technology")

data.raw.item["stone-wall"].order = "a[stone-wall]-a[stone-wall]"
data.raw.item["gate"].order = "a[stone-wall]-b[gate]"
data.raw.item["reinforced-wall"].order = "a[stone-wall]-c[reinforced]"
data.raw.item["reinforced-gate"].order = "a[stone-wall]-d[reinforced]"

data.raw.technology["solar-panel-equipment-3"].prerequisites = { "solar-panel-equipment-2", "titanium-processing" }
table.insert(data.raw.technology["solar-panel-equipment-4"].prerequisites, "alien-technology")

data.raw.technology["night-vision-equipment-2"].prerequisites = { "night-vision-equipment" }
table.insert(data.raw.technology["night-vision-equipment-3"].prerequisites, "alien-technology")

table.insert(data.raw.technology["basic-exoskeleton-equipment-3"].prerequisites, "alien-technology")

table.insert(data.raw.technology["basic-laser-defense-equipment-6"].prerequisites, "alien-technology")

table.insert(data.raw.technology["fusion-reactor-equipment-2"].prerequisites, "alien-research")

table.insert(data.raw.technology["battery-equipment-4"].prerequisites, "alien-research")

table.insert(data.raw.technology["energy-shield-equipment-3"].prerequisites, "alien-technology")
table.insert(data.raw.technology["energy-shield-equipment-4"].prerequisites, "alien-research")
